﻿/*	
 * Created by SharpDevelop.
 * Author: Vincent Tollu 
 * vinzz@altern.org
 * Date: 06/01/2007
 * Time: 12:51
 * 
 * Distributed under the General Public License
 */
using System;
using System.Collections.Generic;
using System.Collections;
using System.IO;
using System.Diagnostics;

namespace aMp3Splitter
{
	class MainClass
	{
		static public Stack DirDeployExplore(DirectoryInfo dSrcDir)
		{
			try
			{
				System.Collections.Stack	stackDirs = new System.Collections.Stack();
				System.Collections.Stack	stackPaths = new System.Collections.Stack();
				
				stackDirs.Push(dSrcDir);
				while (stackDirs.Count > 0 )
				{
					if(stackDirs.Count %50 == 0)
						System.Console.WriteLine("Directories to process: " + stackDirs.Count);
					
					DirectoryInfo currentDir = (DirectoryInfo) stackDirs.Pop();
					
					//Process .\files
					foreach(FileInfo fileInfo in currentDir.GetFiles())
					{
						if(fileInfo.Extension == ".mp3")
							stackPaths.Push(fileInfo.FullName);
					}
	
					//Process Subdirectories
					foreach (DirectoryInfo diNext in currentDir.GetDirectories())
						stackDirs.Push(diNext);
				}
				
				return stackPaths;
			}
			catch(Exception e)
			{
			   Console.WriteLine(e.Message);
               Console.ReadKey();
               return null;
			}
		}
		
		public static void Main(string[] args)
		{
			try
			{
				//Recursively explore the music directory
				DirectoryInfo musicDir;
				if(args.Length == 0)
					 musicDir = new DirectoryInfo(@"c:\Music\");
				else
					musicDir = new DirectoryInfo(args[0]);
				Stack staFiles = DirDeployExplore(musicDir);
				
				System.Console.WriteLine(@"~~~~~~~~~~~~~~~~~~~~~");
				System.Console.WriteLine("Files to process: " + staFiles.Count);
				
				Process proc = new System.Diagnostics.Process();
				proc.EnableRaisingEvents = false;
				
				proc.StartInfo.FileName = @"C:\Program Files\mp3splt\mp3splt.exe";
				
				
				while (staFiles.Count > 0 )
				{
					string stMp3FileInfo = staFiles.Pop() as string;
					
					if(staFiles.Count % (args.Length ==0?10:1) == 0)
					{
						System.Console.WriteLine(@"~~~~~~~~~~~~~~~~~~~~~");
						System.Console.WriteLine("Files to process: " + staFiles.Count);
					}
					
					string argStr = "";
					bool bEnclose = stMp3FileInfo.Contains(" ");
					
					if(bEnclose) argStr += "\"";
					argStr += stMp3FileInfo;
					if(bEnclose) argStr += "\"";
					argStr += " ";
	
					argStr += @" -s -p th=-50,min=10,rm -o @t -g [@o]%[@o,@t=""Hidden"",@n=99]";
					
					proc.StartInfo.Arguments = argStr;
					proc.StartInfo.WindowStyle = ProcessWindowStyle.Hidden;
					proc.Start();
					proc.PriorityClass = ProcessPriorityClass.BelowNormal;
					proc.WaitForExit();
				
				}
			}
			catch(Exception e)
			{
			   Console.WriteLine(e.Message);
               Console.ReadKey();
			}
		}
	}
}
